
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>在YUV图像上根据背景色实现OSD反色 / iVAN</title>

    <meta name="description" content="在YUV图像上根据背景色实现OSD反色 所谓的OSD其实就是在视频图像上叠加一些字符信息,比如时间,地点,通道号等, 在图像上叠加OSD通常有两种方式: 一种是在前端嵌入式设备上,在图像数据上叠加OSD, 这样客户端这边只需解码显示数据即可.另一种是PC客户端在接收到前端设备图像,解码之后,进行叠加.这两种都是比较常见的方式. OSD具有字符型(Font-Based)和位图型(Bit-Map)两种类型. 字符型OSD:为了节约显示缓存,早期及低成本的解决方案中使用字符型OSD发生器,其原理是将OSD中显示内容按照特定的格式(12×18">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">在YUV图像上根据背景色实现OSD反色</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<blockquote><p><strong>所谓的OSD</strong>其实就是在视频图像上叠加一些字符信息，比如时间，地点，通道号等， <br />在图像上叠加OSD通常有两种方式： 一种是在前端嵌入式设备上，在图像数据上叠加OSD， <br />这样客户端这边只需解码显示数据即可。另一种是PC客户端在接收到前端设备图像，解码之后，进行叠加。这两种都是比较常见的方式。</p>
<p>OSD具有字符型(Font-Based)和位图型(Bit-Map)两种类型。</p>
<p><strong>字符型OSD：</strong>为了节约显示缓存，早期及低成本的解决方案中使用字符型OSD发生器，其原理是将OSD中显示内容按照特定的格式(12×18、12×16等)进行分割成块，例如数字0-9、字母a-z、常用的亮度、对比度符号等，并把这些内容固化在ROM或Flash中，在显示缓存中仅存放对应的索引号，这样的“字典”结构可以大幅度减少显示缓存的需求。</p>
<p><strong>位图OSD</strong>：通过对最终显示内容上特定区域的每个像素点进行改变，直接将OSD信息叠加到最终的显示画面上，其按像素进行控制的方式可以保证具有多色及足够的表现能力。 <br />最近做一个网络播放器, 有在播放器实时叠加OSD这个需求,正好借这个机会研究了一下位</p></blockquote>
<h4>最近做一个网络播放器, 有在播放器实时叠加OSD这个需求,正好借这个机会研究了一下。</h4>
<h3>先说下大体流程，</h3>
<ol>
<li>首先，播放SDK，通过网络模块接收前端视频流（经过压缩的数据），然后进行解压，得到一帧完整的YUV图像，</li>
<li>然后，我们在内存中创建一个设备无关的位图，并指定图像数据背景色为白色，字体为黑色。通过DrawTextW将字体画到内存DC上，</li>
<li>之后，通过GetDIBit将位图的二进制位复制到与设备无关的位图buffer里， 然后扫描此位图的每一个像素点，判断每个像素点的R,G,B三个分量之和 ，如果大于384 设置该像素为RGB(255，255，255)， 否则设置为RGB(0,0,0),（384表示灰度）</li>
<li>然后根据图像的宽高，创建一个通明通道数组，通过遍历之前得到的设备无关位图buffer，获取每个像素点的R分量，如果R等于0，则设置通明通道数组中对应的值为1， 表示该像素点上需要绘制字体（换句话说，该像素点不是透明色） <br />这样我们就记住了临时图像上OSD文字每个像素的位置。</li>
<li>接下来，我们将构造出来的bmp位图数据进行转换，转换成YUV420数据，存储在 pOSDYuvBuffer中</li>
<li><strong>下面这一步，就是最主要的地方， 即计算OSD反色的算法，</strong>
<p>我们遍历透明通道数组， 若值等于1， 则说明该像素点是字体，需要绘制， 那么，我们就在源图像（解码后的YUV图像）上找到位置想对应的点。并以该点为中心，计算出一个13*13的矩形区域，此区域作为背景参考区， 遍历该矩形区域 并计算该区域的 Y分量平均值，如果平均值大于128 说明该背景区是亮色，那么，我们设置pOSDYuvBuffer相应像素点的Y分量为1（背景亮，则osd字体为黑色，反之，若背景区为暗色，则设置osd字体像素点的Y为255）</li>
<li>这样扫描结束之后， 就实现了 pOSDYuvBuffer中的OSD字体颜色，根据背景色的反色。然后将我们构造出来的临时图像 叠加到源图像上即可。</li>
<li>至于叠加操作，其实很简单。 同样扫描通明通道数据，如果发现不是透明色，直接将pOSDYuvBuffer中的YUV复制到 源图像相应位置即可。</li>
</ol>
<hr>
<h3>下面是流程：</h3>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjEwMTcxODM4NDg4MjU=.jpg"></p>
<h3>反色计算算法 图</h3>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjEwMTcxODM5NTA1NzY=.jpg"></p>
<pre><code>int posAx=0, posAy=0;
int posDx=0 ,posDy=0;
int nBKColor = 0;
for(i = 0; i &lt; m_OSDHeigth; i++)
{
    for(j = 0; j &lt; m_OSDWidth; j++)
    {
        if(  j+_dwStrPosX&gt;=_VideoWidth || i+_dwStrPosY&gt;=_VideoHeight )
            continue;
    // 找到字符 X
        if( m_palpha[i*m_OSDWidth + j] )// 找到x映射在在源图像上的13*13 背景块
        {
            posAx = _dwStrPosX+j - 3;   // 计算背景色块 A的坐标
            if ( posAx&lt;0 )
                posAx=0;

            posAy = _dwStrPosY+i -3;
            if ( posAy&lt;0 )
                posAy =0;

            posDx =  _dwStrPosX+j + 3;      // 计算背景色块 点D的坐标
            if ( posDx &gt;_VideoWidth)
                posDx =_VideoWidth;

            posDy = _dwStrPosY+i +3;
            if ( posDy &gt;_VideoHeight)
                posDy =_VideoHeight;

            // / 计算背景色块 长,宽
            int height_ = posDy-posAy;
            int width_  = posDx-posAx;

            UINT16* pTempDesY = (UINT16*)dest_buf + posAx + posAy*_VideoWidth;
                int nTemp = 0;
                for ( m=0; m&lt; height_; m++ )//height
                {
                    for ( n=0; n&lt;width_;n++ )
                    {
                        nTemp += ( (*pTempDesY) &gt;&gt;2 );
                        pTempDesY++;
                    }
                    pTempDesY = (UINT16*)dest_buf + posAx + posAy*_VideoWidth + m*_VideoWidth;
                }

                // 计算Y 的平均值
                nBKColor = nTemp/(height_*width_);
                if ( nBKColor &gt;128 )
                    *pY = 0;
                else
                    *pY = ( 255&lt;&lt;2);
            }

            pDesY++;
                pY++;
        }//j
        pDesY = ((UINT16*)dest_buf + _dwStrPosX + _dwStrPosY*_VideoWidth) + i*_VideoWidth;
}//i</code></pre>
<h3>效果图：</h3>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjEwMTcxOTEzMjA4NTY=.jpg"></p>
<hr>
<h4>扫描下方二维码。关注 【音视频开发训练营】</h4>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjEwMTcxOTE1NDIyODI=.jpg"></p>
<p>from:http://blog.csdn.net/machh/article/details/52840886</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 13:59:03</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%95%b0%e7%bb%84/" title="数组">数组</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>在YUV图像上根据背景色实现OSD反色的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvrAQaM.html" rel="bookmark">关于opencv在单通道图像上画矩形框</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 关于opencv在单通道图像上画矩形框 rectangle(img r.tl() r.br()Scalar(00255)-180);这个函数是画3通道的矩形框,但是我的图像是红外图像,网上说是单通道的,不知道怎么在红外图像上画矩形框?求大神解答,灰常感谢!!			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1lZZjb.html" rel="bookmark">在DirectShow的视频图像上叠加线条和文字</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在DirectShow的视频图像上叠加线条和文字 最近一直在从事工业测量方面的开发工作,难免会用到各种各样的相机,其中支持DX的USB相机开发起来比较方便,由于工作需要经常要在视频图像上叠加线条和文字,图1便是我最近一段时间写的一套工业检测系统,图像是从USB相机中实时获取的.看到网上有些帖子也在讨论这个问题,现在给出我的一个非常简单的思路并附上源代码(vc++6.0编译通过,需要连接USB相机,可用普通摄像头来代替.地址:http://xiaolang86.download.csdn.net/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJAOkJp.html" rel="bookmark">代码-去除图像上的红色印章</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 去除图像上的红色印章 请大神指教怎样编写一段可以去除图像上的红色印章的C#代码.因为有些图像上会盖有各种各样红色的印章,甚至有的还盖在了内容上.我需要将这些印章过滤掉,并且不损害内容,请问应该怎么编码? 解决方案 google opencv inpaint algorithm 解决方案二: 参考:http://docs.opencv.org/trunk/doc/py_tutorials/py_photo/py_inpainting/py_inpainting.html			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNjPXJM.html" rel="bookmark">图像处理-VC进行图像反色为什么只能处理部分区域。。（望指正代码哪里出错了）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 VC进行图像反色为什么只能处理部分区域..(望指正代码哪里出错了) 以下是OnPaint函数和反色函数的代码,结果如下图所示图片能完整的显示但只能对部分进行反色操作. void CPictureView::OnPaint() { CPaintDC dc(this); // device context for painting CRect rect; GetClientRect(rect); //得到文档指针 CPictureDoc* pDoc = GetDocument(); ASS			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mvn4q5M.html" rel="bookmark">ios-iOS使用mapkit获取mapView上某一点的坐标反地理编码出来的地址不正确</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 iOS使用mapkit获取mapView上某一点的坐标反地理编码出来的地址不正确 iOS使用mapkit获取mapView上某一点的坐标反地理编码出来的地址不正确.我在网上查了半天没有查到解决办法. 解决方案 你调用mapkit用的是哪个经纬度?你上面有3个经纬度. 解决方案二: 经纬度都对不上,应该是取错点了吧			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/0zGxevb.html" rel="bookmark">RGB与YUV图像视频格式的相互转换</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				显示器图像显示概述: 我们知道普通彩色CRT显示器内部有三支电子枪,电子 枪去激活显示器屏幕的荧光粉,三种荧光粉发射出的光生成一个像素位置的颜色点,这就 是我们人眼能看到的一个像素.每个像素对应红.绿.蓝(R.G.B)三个强度等级,每 个像素占用24位,可以显示近1700 万种颜色,这就是我们所说的真彩色. 普通彩 色CRT显示器是基于电视技术的光栅扫描,电子束一次扫描一行,从顶到底依次扫描,整 个屏幕扫描一次(我们称它为1帧),电子束扫描完一帧后回到最初位置进行下一次扫描 . 电视图像显示概述			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWlmPGp.html" rel="bookmark">【转载】使用SDL播放YUV图像数据（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				SDL提供了针对YUV格式数据的直接写屏操作.废话不多说,直接上代码吧 /** * file showyuv.c * author: rare * date: 2009/12/06 * email: dux003#163.com */ #include &lt;stdlib.h&gt;#include &quot;SDL.h&quot; int main(int argc , char* argv[]){    int i = 1;    int x, y;    int w = 176;    int			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVXOBmM.html" rel="bookmark">在java中如何获取在画布加载的图像上用鼠标点击的字符&lpar;图像上有很多字符&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 例如,我把一个小地图图像加载在canvas画布上,我鼠标点击小地图图像,怎么获取鼠标点击的地点(比如我点击的是火车站),java怎么知道我点的就是火车站,而不是其他地点的 解决方案 解决方案二:思路,给画布加入鼠标监听器addMouseListener,addMouseMotionListener,监听方法里event.getPoint()返回鼠标位置你的火车站,最起码要保留x,ywidthheight4个数据,可以建成Rectangle或其它形状(Shape的子类)Rectangle			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPk33qM.html" rel="bookmark">ASP&period;NET treeview节点鼠标移上去时背景色变化问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 属性设置中HoverStyle=&quot;background:#6079d2;color:#ffffff&quot;,SelectedStyle=&quot;background:#6079d2;color:#ffffff&quot;节点选中时和鼠标移到节点时背景色设置成同样颜色,但实际效果中鼠标移上去的颜色要淡很多,SelectedStyle中#6079d2这个颜色生效了,色彩是对的,但是HoverStyle的颜色始终要淡,达不到我设置的颜色,求高人解答!!!!!!!! 解决方案 解决方案			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvWjrp.html" rel="bookmark" class="title">fatal error&colon;php中通过register</a>
					<div>
						今天发现php中,如果要记录fatal error的时候,可以实用一个不错的函数, 叫register_shutdown_function,小结如下:   register_shutdown_func ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzw7Nkz.html" rel="bookmark" class="title">PHP教程&period;应用实例11</a>
					<div>
						教程|应用实例 PHP应用提速面面观PHP最大的优点之一显然在于它的快速度.一般情况下PHP总是具有足够的速度支持Web内容动态生成,许多时候你甚至无法找出比它更快的方法.然而,当你不得不面对庞大的访 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpP1qAz.html" rel="bookmark" class="title">联举软件政府专网防火墙解决方案</a>
					<div>
						一.某市政府网络系统现状分析 &lt;某市电子政务工程总体规划方案&gt;主要建设内容为:一个专网(政务通信专网),一个平台(电子政务基础平台),一个中心(安全监控和备份中心),七大数据库(经济信息数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbEn0oM.html" rel="bookmark" class="title">IIS 更新ScriptMaps</a>
					<div>
						iis A zip file with your code and stylesheet is also available for download. Make sure you right cli ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1Y4KM.html" rel="bookmark" class="title">网站跳出率过高怎么处理？</a>
					<div>
						经营网站并不是只要把关键词优化上去,带来了流量这么简单,有了流量后,我们就需要关注网站跳出率.什么是网站跳出率?网上的解释:仅仅访问了单个页面的用户占全部访问用户的百分比,简单来说就是只访问了一个页面 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpn2xop.html" rel="bookmark" class="title">如何从统计数据中分析网站推广效果</a>
					<div>
						作为一个理科出身的站长,对于分析数据这一块其实是比较头大的,毕竟谁也不喜欢对于一串串的数字进行仔细的分析,这需要多大的耐心啊.但是如果不分析统计数据的话,就连掌握自己的推广方法是否真的有效果都不知道, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlP8Wb.html" rel="bookmark" class="title">用Delphi实现Singleton模式</a>
					<div>
						单例模式用于限制进程中只有一个某个类的对象,本例的Singleton是一个线程实例,在每一个时钟到达时检测是否到达某个时刻(本例的时刻存于Ini文件中),如果到达则产生一个线程,但是如果在这个线程完成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2y15Zz.html" rel="bookmark" class="title">如何使tcp包和udp包穿透防火墙</a>
					<div>
						通过本文的httptunnel 技术同时逃过了防火墙的屏蔽以及系统的追踪试验,我们可以看到网络安全仅仅依靠某种或某几种手段是不可靠的,同时对安全系统的盲目性依赖往往会造成巨大的安全隐患.希望通过本文能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJ7R9Vb.html" rel="bookmark" class="title">用动态规划算法对最大子串问题的java实现</a>
					<div>
						最大字串问题描述大概就是给定2个字符串,找出他们两个共有的最长字符串.比如一个是&quot;tabcfg&quot;另外一个&quot;abckj&quot;那么最大子串就是&quot;abc&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2y7ekz.html" rel="bookmark" class="title">Win8&period;1系统怎么进入安全模式</a>
					<div>
						  方法一:勾选安全引导项 使用[Win]+[R]组合快捷键快速调出开始运行对话框,然后键入 msconfig 命令打开&quot;系统配置&quot;设置,然后切换到&quot;引导&quot;菜单 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGKD8p.html" rel="bookmark" class="title">EXCEL中的条件格式转成普通格式</a>
					<div>
						工作表里设置了一个条件格式,工作表就变成了漂亮的&quot;地砖&quot;,如下图: 贴到 WORD 里以后: 再贴回 EXCEL 中,没有了条件格式,但是&quot;地砖&quot;保留了: 20 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEWZeLp.html" rel="bookmark" class="title">网上看奥运直播神器--中国网络电视台客户端</a>
					<div>
						2012伦敦奥运会来了,不能看电视只能电脑上网的朋友是不是还在网上到处找可以看直播的地方呢.今天给大家推荐的就是一款可以看奥运直播的软件,可以看所有CCTV频道的直播,也可以看各个省市电视台直播的软件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z42R2rM.html" rel="bookmark" class="title">巧用photoshop&plus;sai给可爱小女孩做转手绘效果</a>
					<div>
						  巧用photoshop+sai给可爱小女孩做转手绘效果,非常赞的效果,简单粗暴,耐心的绘画过程,有兴趣的可以自己试试   相关阅读: Photoshop仿手绘教程,照片转手绘详细流程 Photos ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZ9VDz.html" rel="bookmark" class="title">指令-C&num; 实现语音相关的功能</a>
					<div>
						问题描述 C# 实现语音相关的功能 利用C# 开发语音功能,实现如下场景功能: 1.利用开发的语音功能,实现在第三方系统中用语音功能代替文字的手工录入: 2.利用开发的语音功能,实现打开第三方系统功能 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkqjvb.html" rel="bookmark" class="title">透视Facebook算法帝国 ，我们只是工程思维的螺丝钉</a>
					<div>
						本文讲的是透视Facebook算法帝国 ,我们只是工程思维的螺丝钉 扎克伯格对黑客的幼稚迷恋从未消失 硅谷所自称的所有价值都是60年代的价值.大型科技公司将自己当做个人解放的平台.人人都有权在社交媒体 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkwV7b.html" rel="bookmark" class="title">程序员屌丝逆袭之路不是炒股</a>
					<div>
						最近这一段时间,你身边是不是大多数人都在谈论股票?那就对了,无论走到哪都能听到,今天又绿了,我的股票跌停了,冲上5000点啦,等等之类的话. 我还不是一个股民,一直都不是.因为不懂,不敢入市:因为有人 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bamQN2b.html" rel="bookmark" class="title">【云中沙箱】如何进行阿里云ECS的备份和恢复？</a>
					<div>
						如何进行阿里云ECS的备份和恢复? 云中沙箱实验&quot;ECS的磁盘挂载.快照及自定义镜像&quot;,教您快速掌握阿里云ECS的备份和恢复.   云中沙箱,阿里云官方实验平台.网址:http:/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boR9A3z.html" rel="bookmark" class="title">【OpenCV】访问Mat图像中每个像素的值 &lpar;II&rpar;</a>
					<div>
						今天百度搜资料还搜到了自己的...&lt;访问图像中每个像素的值&gt;,这是之前写的了,用的也是2.0的风格IplImage*格式,不太适用后来Mat的格式,特此重写一篇. 以下例子源自&lt;Th ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYoxOp.html" rel="bookmark" class="title">vb net-寻找一位会用VB&period;NET编写ASP&period;NET的师兄，有些问题请教！！</a>
					<div>
						问题描述 寻找一位会用VB.NET编写ASP.NET的师兄,有些问题请教!! 寻找一位会用VB.NET编写ASP.NET的师兄,有些问题请教!!谢谢!!!! 解决方案 我没学过VB.NET,但我正在学 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKVwjb.html" rel="bookmark" class="title">七岁的OpenStack成熟了？企业就绪了？</a>
					<div>
						中国福利彩票发行管理中心(以下简称福彩中心)今年开始启用了一个新的云计算平台,这是一个基于OpenStack的私有云解决方案,用于支持其福利彩票的日常管理和运营.目前,福彩中心技术人员正在将业务逐渐向 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmJl1b.html" rel="bookmark" class="title">VB6&period;0关于主菜单控件位置的设置的问题</a>
					<div>
						问题描述 VB6.0关于主菜单控件位置的设置的问题 菜单条控件的Top和Width属性可以在哪里设置呢?在VBasic 6.0语言中,没有找到对应的属性的设置. 解决方案 将菜单条装入工具条,工具条可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjLKa6p.html" rel="bookmark" class="title">jQuery中ajax的load&lpar;&rpar;与post&lpar;&rpar;方法实例详解&lowbar;jquery</a>
					<div>
						本文实例讲述了jQuery中ajax的load()与post()方法.分享给大家供大家参考,具体如下: 一.load()方法 在jQuery ajax的load()方法能够载入远程 HTML 文件代码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRoaAb.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;juju猫&rdquo;网站被端提供盗版Win7疯狂下载</a>
					<div>
						■警方昨日在发布会上展示缴获的假冒名牌手表.通讯员供图 广东重拳打击侵犯知识产权及制售假冒伪劣商品,发起3宗跨省专案集群战役 ■新快报记者 刘操 通讯员 孙祥美 张雷 昨日,广东省公安厅召开新闻发布会 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQjNawM.html" rel="bookmark" class="title">mfc-读取位置 0x00000000 时发生访问冲突。</a>
					<div>
						问题描述 读取位置 0x00000000 时发生访问冲突. 0x1042D8D2 (mfc120ud.dll) (ConfigFileGen.exe 中)处有未经处理的异常: 0xC0000005:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwLr8M.html" rel="bookmark" class="title">c&plus;&plus;-失踪的存储类或类型说明符</a>
					<div>
						问题描述 失踪的存储类或类型说明符 新手用c++在搞一个图书资料管理系统,把book的类写在头文件中,但是编译时候出现的错误玩去无法理解,求助大神解答一下! 万分感谢!!! 解决方案 解决方案二: 解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4eArqb.html" rel="bookmark" class="title">MFC－消息分派</a>
					<div>
						前言        由于工作需要,这几天学了一点MFC,在AFX里看到很多熟悉的东西,如类型信息,序列化,窗口封装和消息分派.几乎每个界面库都必须提供这些基础服务,但提供的手法却千差万别.MFC大量地 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRBRop.html" rel="bookmark" class="title">张小东：巨头垄断高端芯片的国际格局有望被打破</a>
					<div>
						全球异构系统架构(HSA)联盟中国区域委员会主席.中国异构计算标准工作组主席张小东25日在厦门表示,人工智能产业链的形成和大规模的应用可令产品的性价比迅速提高,促进&quot;中国时代&quot;的来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGZk8np.html" rel="bookmark" class="title">《21天学通Java（第6版）》&mdash;&mdash; 1&period;10　练习</a>
					<div>
						1.10 练习 21天学通Java(第6版) 为巩固今天介绍的知识,请尝试完成下面的练习. 1．在VolcanoApplication类的main( )方法中,再创建一个名为virgil的Volcan ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6xBXM.html" rel="bookmark" class="title">谁开发过网页中的聊天工具么？</a>
					<div>
						问题描述 我想做一个网页聊天工具就像csdn右下方的即时聊天一样!哪位做过相关的开发可否给个参考!或指点一下!很急!谢了!					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1e2rb.html" rel="bookmark" class="title">咋回事？苹果iCloud&OpenCurlyDoubleQuote;入驻&rdquo;中国页面被删</a>
					<div>
						昨日有消息称,江西抚州市政府公开信息显示,苹果公司开始将iCloud中国用户数据迁移至中国电信云存储.如果这是真的,小伙伴们确实要欢天喜地了.因为苹果iCloud服务器一直在国外,国内用户访问苹果AP ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 12 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
